/******************************************************************************
*******************************************************************************
**
**  Copyright (C) Sistina Software, Inc.  1997-2003  All rights reserved.
**  Copyright (C) 2004 Red Hat, Inc.  All rights reserved.
**
**  This copyrighted material is made available to anyone wishing to use,
**  modify, copy, or redistribute it subject to the terms and conditions
**  of the GNU General Public License v.2.
**
*******************************************************************************
******************************************************************************/

#ifndef __QUOTA_DOT_H__
#define __QUOTA_DOT_H__

#define NO_QUOTA_CHANGE ((uint32_t)-1)

int gfs_get_qdstruct(struct gfs_sbd *sdp, int user, uint32_t id, int create,
		     struct gfs_quota_data **qdp);
void gfs_hold_qdstruct(struct gfs_sbd *sdp, struct gfs_quota_data *qd);
void gfs_put_qdstruct(struct gfs_sbd *sdp, struct gfs_quota_data *qd);

void gfs_quota_scan(struct gfs_sbd *sdp);
int gfs_quota_merge(struct gfs_sbd *sdp, struct gfs_quota_tag *tag);
void gfs_quota_cleanup(struct gfs_sbd *sdp);

int gfs_quota_sync(struct gfs_sbd *sdp);

int gfs_hold_quota_structs(struct gfs_inode *ip, uint32_t uid, uint32_t gid);
void gfs_unhold_quota_structs(struct gfs_inode *ip);

int gfs_get_quota_locks(struct gfs_inode *ip, uint32_t uid, uint32_t gid,
			int *cred);
void gfs_put_quota_locks(struct gfs_inode *ip);

int gfs_check_quota(struct gfs_inode *ip, uint32_t uid, uint32_t gid);

int gfs_quota_refresh(struct gfs_sbd *sdp, void *arg);
int gfs_quota_get(struct gfs_sbd *sdp, void *arg, int *cred);

#endif				/*  __QUOTA_DOT_H__  */
