%option nounput
%option noyywrap
%{
/******************************************************************************
*******************************************************************************
**
**  Copyright (C) Sistina Software, Inc.  1997-2003  All rights reserved.
**  Copyright (C) 2004 Red Hat, Inc.  All rights reserved.
**
**  This copyrighted material is made available to anyone wishing to use,
**  modify, copy, or redistribute it subject to the terms and conditions
**  of the GNU General Public License v.2.
**
*******************************************************************************
******************************************************************************/

#include <string.h>
#include <stdlib.h>
#include "y.tab.h"
#include "osi_user.h"
#include "sisstring.h"
#include "sislogger.h"
#include "libpool.h"
#include "libpool_internal.h"

extern int lineno;
static int tokenpos = 0;
char linebuf[500] = {0};

/** 
 * yyerror - prints out an error message
 * @s - message to prints
 *
 */
int yyerror (char *s)
{
   if(yytext && strlen(yytext) > 0) {
     log_err("line %d: %s at \"%s\"", lineno, s, yytext);
   }
   else {
     log_err("line %d: %s", lineno, s, yytext);
   }
   return 0;
}


%}

number	[0-9]+
string  [^ \t\n\/]+
devstr  [^ \t\n]+
ws	[ \t]+
comment #.*
nl	\n

%%
{ws}		{ strcpy(linebuf, yytext); tokenpos += yyleng;}
{number}	{ strcpy(linebuf, yytext); tokenpos += yyleng; yylval.num = atoi(yytext); return NUMBER; }
poolname	{ strcpy(linebuf, yytext); tokenpos += yyleng; return POOLNAME; }
minor		{ strcpy(linebuf, yytext); tokenpos += yyleng; return MINOR; }
subpools	{strcpy(linebuf, yytext); tokenpos += yyleng; return SUBPOOLS; }
subpool         {strcpy(linebuf, yytext); tokenpos += yyleng; return SUBPOOL; }
pooldevice	{strcpy(linebuf, yytext); tokenpos += yyleng; return POOLDEV; }
{comment}	{strcpy(linebuf, yytext); tokenpos += yyleng;}
{string}	{strcpy(linebuf, yytext); tokenpos += yyleng; yylval.str = strdup(yytext); return STRING; }
{devstr}        {strcpy(linebuf, yytext); tokenpos += yyleng; yylval.str = strdup(yytext); return DEVICESTR; }
{nl}		{ /*strncpy(linebuf, yytext+1, 500);
		  memset(linebuf, 0, sizeof(char) * 500);
	          linebuf[499] = '\0';
	          tokenpos = 0 ; */
		  lineno++;
		}

