/******************************************************************************
*******************************************************************************
**
**  Copyright (C) Sistina Software, Inc.  1997-2003  All rights reserved.
**  Copyright (C) 2004 Red Hat, Inc.  All rights reserved.
**  
**  This copyrighted material is made available to anyone wishing to use,
**  modify, copy, or redistribute it subject to the terms and conditions
**  of the GNU General Public License v.2.
**
*******************************************************************************
******************************************************************************/
#ifndef __CCS_ONDISK_H__
#define __CCS_ONDISK_H__
#include "osi_user.h"
/* A CCS device is divided into two sections.  Each section is composed of **
** a header and an archive.  Each section is of size dh_maxsize.           **
**                                                                         **
** There exist two sections to a CCS device so that atomic changes can     **
** be made to it's contents.  This is done by writting changes to the      **
** inactive section and then changing the active fields in the headers.    **
** Since the headers exist in their own sector on disk, the change is      **
** atomic.                                                                 */


#define CCS_DH_MAGIC  0x122473

/* CCS Device Header */
typedef struct ccs_dh_s {
  uint32 dh_magic;
  uint32 dh_format;
  uint32 dh_generation;
  uint32 dh_active;
  uint32 dh_size;     /* Size of archive on disk */
  uint32 dh_maxsize;
  char   dh_reserved[64];
} ccs_dh_t;

void ccs_dh_in(ccs_dh_t *, char *);
void ccs_dh_out(ccs_dh_t *, char *);

#endif /* __CCS_ONDISK_H__ */

