/******************************************************************************
*******************************************************************************
**
**  Copyright (C) Sistina Software, Inc.  2003  All rights reserved.
**  Copyright (C) 2004 Red Hat, Inc.  All rights reserved.
**
**  This copyrighted material is made available to anyone wishing to use,
**  modify, copy, or redistribute it subject to the terms and conditions
**  of the GNU General Public License v.2.
**
*******************************************************************************
******************************************************************************/

#define GNBD_RELEASE_NAME "v6.0.0"

#include "servd.h"
#include <linux/gnbd_request.h>
#include "device.h"
#include "gserv.h"
#include "fence.h"
#include "interfaced.h"
#include <linux/init.h>

MODULE_AUTHOR("Red Hat, Inc.");
MODULE_DESCRIPTION("Global Network Block Device Server " GNBD_RELEASE_NAME);
MODULE_LICENSE("GPL");

static int port = 0;
MODULE_PARM(port, "i");
MODULE_PARM_DESC(port, "Used to change the port that gnbd_servd listens on.");

int __init
init_gnbd_serv(void)
{
	int err;

	init_gnbd_requestd();
	init_gserv_device();
	init_gserv();
	init_fence();
	init_interface();

	err = start_gnbd_servd(port);
	if (err) {
		printe("failed to start up gnbd_servd\n");
		goto fail;
	}

	printk("GNBD_SERV %s (built %s %s) installed\n",
	       GNBD_RELEASE_NAME, __DATE__, __TIME__);
	return 0;

      fail:
	return err;
}

void __exit
exit_gnbd_serv(void)
{
	stop_gnbd_servd();
	clear_banned_list();
	clear_timestamp_list();

	return;
}

module_init(init_gnbd_serv);
module_exit(exit_gnbd_serv);

EXPORT_NO_SYMBOLS;
