/******************************************************************************
*******************************************************************************
**
**  Copyright (C) Sistina Software, Inc.  1997-2003  All rights reserved.
**  Copyright (C) 2004 Red Hat, Inc.  All rights reserved.
**
**  This copyrighted material is made available to anyone wishing to use,
**  modify, copy, or redistribute it subject to the terms and conditions
**  of the GNU General Public License v.2.
**
*******************************************************************************
******************************************************************************/

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "global.h"
#include "gnbd_import.h"
 
int list_match(char *name, devlist_t *ptr){
  while (ptr != NULL){
    if (strcmp(name, ptr->name) == 0)
      return (int)ptr->minor_nr;
    ptr = ptr->next;
  }
  return -1;
}

devlist_t *list_add(devlist_t *elem, devlist_t *head){
  devlist_t *prev, *ptr;
  if (head == NULL || head->minor_nr > elem->minor_nr){
    elem->next = head;
    return elem;
  }
  prev = head;
  ptr = head->next;
  while (ptr != NULL){
    if (ptr->minor_nr > elem->minor_nr){
      prev->next = elem;
      elem->next = ptr;
      return head;
    }
    prev = ptr;
    ptr = ptr->next;
  }
  prev->next = elem;
  elem->next = NULL;
  return head;
}


devlist_t *clear_list(devlist_t *ptr){
  devlist_t *tmp;
  while(ptr != NULL){
    tmp = ptr;
    ptr = ptr->next;
    free(tmp);
  }
  return NULL;
}


void clear_servlist(servlist_t *ptr){
  servlist_t *tmp;
  while (ptr != NULL){
    tmp = ptr;
    ptr = ptr->next;
    free(tmp);
  }
  return;
}
